﻿/*
* @author July
* 
* var my_scroll:Scroll = new Scroll(mcScroll,		// target scroll movie 
* 									mcScroll._mc,	// moving container (movie what need scroll)
* 									"mcDragArea",	// movie linkage name for dragging area
* 									"mcDragger",	// movie linkage name for dragger
* 									256,			// scroll width
* 									300,			// scroll height
* 									true,			// enable dragging area
* 									true,			// enable dragger
* 									true,			// enable controls - top and down buttons
* 									deceleration,	// scroll deceleration
* 									factor,			// factor mouse wheel
* 									space,			// space between controls and dragging area (need if enable controls "true")
* 									rate,			// step controls press (need if enable controls "true")
* 									"mcCtrlTop",	// movie linkage name for scroll button top (need if enable controls "true")
* 									"mcCtrlDown");	// movie linkage name for scroll button down (need if enable controls "true")
* 
*/
//import mx.data.types.Str;
import mx.utils.Delegate

class com.ui.Scroll
{
	private var target_mc:MovieClip;
	private var container_mc:MovieClip;
	private var mask_mc:MovieClip;
	private var dragArea_mc:MovieClip;
	private var dragger_mc:MovieClip;
	private var control1_mc:MovieClip;
	private var control2_mc:MovieClip;
	
	private var dragAreaName:String;
	private var draggerName:String;
	private var ctrl1Name:String;
	private var ctrl2Name:String;
	
	private var draggerTopY:Number;
	private var draggerBottY:Number;
	private var containerStartY:Number;
	private var containerEndY:Number;
	private var draggingH:Number;
	
	private var _ratio:Number;
	private var _distance:Number;
	private var _positionCont:Number;
	private var _deceleration:Number;
	private var _factor:Number;
	private var _delta:Number;
	private var _rate:Number;
	
	private var enableDragger:Boolean;
	private var enableDragArea:Boolean;
	private var enableControls:Boolean;
	
	private static var maskDepth:Number = 2
	private static var dragAreaDepth:Number = 3;
	private static var draggerDepth:Number = 4;
	private static var controlDepth_1:Number = 5;
	private static var controlDepth_2:Number = 6;
	
	public function Scroll (target:MovieClip, 
							container:MovieClip,
							dragarea_str:String,
							dragger_str:String,
                            w:Number, 
                            h:Number,
							draggerArea_enable:Boolean,
							dragger_enable:Boolean,
							controls_enable:Boolean,							
							deceleration:Number,
							factor:Number,
							deltaControls:Number,
							rateControls:Number,
							control1_str:String,
							control2_str:String){
								
		target_mc = target; 
		container_mc = container;
		dragAreaName = dragarea_str;
		draggerName = dragger_str;
		ctrl1Name = control1_str;
		ctrl2Name = control2_str;
		
		enableDragArea = draggerArea_enable;
		enableDragger = dragger_enable;
		enableControls = controls_enable;
	
		_deceleration = deceleration;
		_factor = factor;
		_delta = deltaControls;
		_rate = rateControls;
		
		buildScroll(w, h);						
	}
	
	private function buildScroll (w:Number, h:Number):Void{

		if (container_mc._height > h){
 
			createMask (w, h);
			createDragging (w, h);
			initScroll(w, h);
			doScroll(w, h);
		}
		/*
		else {
			//trace("NO SCROLL")
			//container_mc._x = (w - container_mc._width) / 2; 
		}*/
	}

	private function createMask (w:Number, h:Number):Void {
		// Only create the mask if a valid width and height are specified.
		if (!(w > 0 && h > 0)) {
		  return;
		}
		mask_mc = target_mc.createEmptyMovieClip("mcMask", maskDepth);
		
		mask_mc.moveTo(0, 0);
		mask_mc.beginFill(0x66CC00);  // Use green for debugging.
		mask_mc.lineTo(w, 0);
		mask_mc.lineTo(w, h);
		mask_mc.lineTo(0, h);
		mask_mc.lineTo(0, 0);
		mask_mc.endFill();
	  
		mask_mc._visible = false; 
		container_mc.setMask(mask_mc);
	}

	private function createDragging (w:Number, h:Number):Void {
			
		dragArea_mc = target_mc.attachMovie(dragAreaName, dragAreaName, dragAreaDepth);
		dragger_mc = target_mc.attachMovie(draggerName, draggerName, draggerDepth);

		if (enableControls){
			control1_mc = target_mc.attachMovie(ctrl1Name, ctrl1Name, controlDepth_1);
			control2_mc = target_mc.attachMovie(ctrl2Name, ctrl2Name, controlDepth_2);
			
			control1_mc._x = w - control1_mc._width;
			control2_mc._x = control1_mc._x;
			control2_mc._y = h - control2_mc._height;
			
			dragArea_mc._x = control1_mc._x + (control1_mc._width - dragArea_mc._width)/2;
			dragArea_mc._y = control1_mc._y + control1_mc._height+_delta;
			dragArea_mc._height = h - control1_mc._height - control2_mc._height - 2 * _delta;
			
			dragger_mc._x = control1_mc._x;
			dragger_mc._y = dragArea_mc._y;
			
			if (!enableDragArea) dragArea_mc._visible = false;
			if (!enableDragger) dragger_mc._visible = false;
			
		} else {
			dragArea_mc = target_mc.attachMovie(dragAreaName, dragAreaName, dragAreaDepth);
			dragArea_mc._x = w - dragArea_mc._width;
			dragArea_mc._height = h;
		
			dragger_mc = target_mc.attachMovie(draggerName, draggerName, draggerDepth);
			if (dragger_mc._width = dragArea_mc._width) dragger_mc._x = dragArea_mc._x;
			if (dragger_mc._width > dragArea_mc._width) {
				dragger_mc._x = dragArea_mc._x;
				dragArea_mc._x = dragger_mc._x + (dragger_mc._width - dragArea_mc._width)/2;
			}
			if (dragger_mc._width < dragArea_mc._width) dragger_mc._x = dragArea_mc._x + (dragArea_mc._width-dragger_mc._width)/2;
		}
	}
	
	private function initScroll(w:Number, h:Number):Void{
		
		draggingH = dragArea_mc._height - dragger_mc._height;
		draggerTopY = dragger_mc._y;
		if (enableControls) draggerBottY = dragArea_mc._y + draggingH;
		else draggerBottY = draggingH;
		
		containerStartY = container_mc._y;
		containerEndY = - container_mc._height + h;
			
		_positionCont = containerStartY;
		_ratio = (container_mc._height - mask_mc._height) / draggingH;
	}
	
	private function doScroll():Void{
		
		var topY:Number = draggerTopY;
		var bottY:Number = draggerBottY;
		var dragger:MovieClip = dragger_mc;
		var step:Number = _rate;
		
		dragger.onPress = function(){
			this.startDrag(false, this._x, 0, this._x, bottY);
		}
		
		dragger.onRelease = dragger_mc.onReleaseOutside = function(){
			this.stopDrag();
		}
		
		control1_mc.onPress = function(){
			this.onEnterFrame = function(){
				var newDraggerY:Number = dragger._y - step;
				if(newDraggerY>topY) dragger._y = newDraggerY;
				else dragger._y = topY;
			}
		}
	    
		control2_mc.onPress = function(){
			this.onEnterFrame = function(){
				var newDraggerY:Number = dragger._y + step;
				if(newDraggerY<bottY) dragger._y = newDraggerY;
				else dragger._y = bottY;
			}
		}
		
		control1_mc.onRelease = control2_mc.onRelease = function(){
			delete this.onEnterFrame;
		}
		Mouse.addListener(this);
		moving();
	}
	
	private function moving():Void {
		container_mc.onEnterFrame = Delegate.create(this, moveContents);
	}
	
	private function onMouseWheel(_delta:Number):Void {
		if (mask_mc.hitTest(_root._xmouse, _root._ymouse, false)){
			dragger_mc._y -= _delta * _factor;
		}
	}

	private function moveContents ():Void{
		setInterval(this, 'scroll', 1000/24);
		_distance = dragger_mc._y-draggerTopY;
		_positionCont = -_ratio * _distance;
						
		if (_positionCont>containerStartY) {
			_positionCont = containerStartY;
			dragger_mc._y = draggerTopY;
		}
		
		if (_positionCont<containerEndY) {
			_positionCont = containerEndY;
			dragger_mc._y = draggerBottY;
		}
		
		container_mc._y += (_positionCont-container_mc._y)/_deceleration;
		if (Math.abs(_positionCont-container_mc._y)<1) {
			container_mc._y = _positionCont;
		}
	}
	
	private function disableScroll():Void {
		container_mc._y = containerStartY;
        dragger_mc._y = draggerTopY;
		delete container_mc.onEnterFrame;
		delete dragger_mc.onPress;
		delete dragger_mc.onRelease;
		delete dragger_mc.onReleaseOutside;
		mask_mc.removeMovieClip();
        dragger_mc.removeMovieClip();
        dragArea_mc.removeMovieClip();
		Mouse.removeListener(this);
	}
	
	public function setScrollControls(_x1:Number, _y1:Number, _x2:Number, _y2:Number):Void {
		control1_mc._x = _x1;
		control1_mc._y = _y1;
		control2_mc._x = _x2;
		control2_mc._y = _y2;
	}
	
	public function resetScroll():Void {
		disableScroll();
	}
	
	public function activateScroll():Void {
		doScroll();
	}
}